##########################################################################
##########################################################################
##
##  Licensed Materials - Property of IBM
##
##  IBM TCP/IP for DOS.
##  Copyright IBM Corp. 1992, 1993. All rights reserved.
##  US Government Users Restricted Rights - Use, duplication or
##  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
##
##########################################################################

# Directory for this project
DIR       = SAMPLES
MODEL     = L
SOURCES   = selects.c udpc.c tcpc.c
TARGET    = selects.exe
STACKSIZE = 0x1000
!if "$(MODEL)" == "P"
DEFINES   = /DRATIONAL
INCLUDES  = /I ..\include
!endif

!ifdef debug
DEBUG_CFLAGS = /Zi /Od
DEBUG_LFLAGS = /CO
!else ifdef DEBUG
DEBUG_CFLAGS = /Zi /Od /Fc
DEBUG_LFLAGS = /CO
!endif

COBJS=  selects.obj
CFLAGS= /c /f- /nologo /A$(MODEL) /W3 $(DEBUG_CFLAGS)
LFLAGS= /stack:$(STACKSIZE) $(DEBUG_LFLAGS)
LIBES=  ..\..\lib\socket$(MODEL).lib ..\..\lib\tcputil$(MODEL).lib

ALL:  SELECTS.EXE SENDMSG.EXE SENDFILE.EXE

SELECTS.EXE:     SELECTS.OBJ
        link $(LFLAGS) SELECTS,SELECTS.EXE,,$(LIBES);

SENDMSG.EXE:     SENDMSG.OBJ
        link $(LFLAGS) SENDMSG,SENDMSG.EXE,,$(LIBES);

SENDFILE.EXE:     SENDFILE.OBJ
        link $(LFLAGS) SENDFILE,SENDFILE.EXE,,$(LIBES);

selects.obj: selects.c
        cl $(CFLAGS) selects.c
